#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <time.h>
#include "hdfi.h"

#include "porting_defines.h"
#include "crisSisGetUtilities.h"
#include "utilities.h"

#define HEADER_SIZE 32

uint32* getArchiveFilesStopTimeStamps(int day1996, char *structName) {
    char path[256];
    struct tm *pTimeStruct;
    char instrumentID;
    char dataFileSuffix[10];
    uint32 *pStopStamps_0, *pStopStamps;
    char *buffer_0, *buffer;
    uint32 stopTimeStamp;
    
    int structSize, structCount, i, fd;

    instrumentID = getInstrumentIDFromStructName(structName);
    getDataFileSuffixFromStructName(dataFileSuffix, structName);
    pTimeStruct = getDateFromDay1996(day1996);
    generateDataFilePath(path, pTimeStruct, instrumentID, dataFileSuffix);

    if (!fileExists(path)) {
	pStopStamps_0 = calloc(1, sizeof(uint32));
	pStopStamps_0[0] = 0;
	return pStopStamps_0;
    }

    structSize = getStructSizeFromName(structName);
    structCount = getFilesStructCount(path, structSize, 1);
    buffer_0 = calloc(structCount, structSize);
    fd = open(path, O_RDONLY | O_BINARY, 0);
    lseek(fd, HEADER_SIZE, 0);	/* get past file header */
    read(fd, buffer_0, (structCount * structSize));
    close(fd);

    buffer = buffer_0;
    pStopStamps_0 = calloc(structCount + 1, sizeof(uint32));
    pStopStamps = pStopStamps_0;
    for (i = 0; i < structCount; i++) {
	stopTimeStamp = getStopTimeStamp(buffer, structName);
	if (stopTimeStamp > 0) {
	    *pStopStamps = stopTimeStamp;
	    pStopStamps++;
	}
	buffer += structSize;
    }
    *pStopStamps = 0L;

    free(buffer_0);

    return pStopStamps_0;
}
